panelapp/api/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.conf import settings
from django.urls import (
    include,
    path,
)
from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from .permissions import ReadOnlyPermissions

schema_view = get_schema_view(
    openapi.Info(
        title="PanelApp API",
        default_version=settings.REST_FRAMEWORK["DEFAULT_VERSION"],
        description="PanelApp API",
        terms_of_service="https://panelapp.genomicsengland.co.uk/policies/terms/",
        contact=openapi.Contact(email="panelapp@genomicsengland.co.uk"),
        license=openapi.License(name="MIT License"),
    ),
    patterns=["api"],
    validators=["flex", "ssv"],
    public=True,
    permission_classes=(ReadOnlyPermissions,),
)

app_name = "api"
urlpatterns = [path("v1/", include("api.v1.urls", namespace="v1"))]

panelapp/panels/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.urls import re_path
from django.views.generic import RedirectView

from panels.views.feedback import (
    clear_entity_mode_of_pathogenicity_view,
    clear_entity_phenotypes_view,
    clear_entity_publications_view,
    clear_entity_source_for_entity_list_view,
    clear_entity_source_view,
    clear_entity_sources_view,
    clear_entity_transcript_view,
    delete_entity_comment_view,
    delete_evaluation_by_user_view,
    edit_entity_comment_form_view,
    panel_entity_detail_view,
    toggle_entity_ready_view,
    update_entity_moi_view,
    update_entity_mop_view,
    update_entity_phenotypes_view,
    update_entity_publications_view,
    update_entity_rating_view,
    update_entity_tags_view,
)

from .ajax_views import (
    ApproveEntityAjaxView,
    ApprovePanelAjaxView,
    DeleteEntityAjaxView,
    DeletePanelAjaxView,
    RejectPanelAjaxView,
    SubmitEntityCommentFormAjaxView,
)
from .enums import VALID_ENTITY_FORMAT
from .views import (
    ActivityListView,
    AdminUploadGenesView,
    AdminUploadPanelsView,
    AdminUploadReviewsView,
    AdminView,
    CompareGeneView,
    ComparePanelsView,
    CopyReviewsView,
    CreatePanelView,
    DownloadAllGenes,
    DownloadAllPanels,
    DownloadAllRegions,
    DownloadAllSTRs,
    DownloadPanelTSVView,
    DownloadPanelVersionTSVView,
    EntitiesListView,
    EntityDetailView,
    EntityReviewView,
    GeneDetailRedirectView,
    GenePanelView,
    OldCodeURLRedirect,
    PanelAddEntityView,
    PanelEditEntityView,
    PanelMarkNotReadyView,
    PanelsIndexView,
    PromotePanelView,
    RedirectGenesToEntities,
    UpdatePanelView,
)

app_name = "panels"

entity_types = "gene|str|region"
TYPE_PARAM = f"(?P<entity_type>({entity_types}))"
NAME_PARAM = f"(?P<entity_name>{VALID_ENTITY_FORMAT})"
PK_PARAM = "(?P<pk>[0-9]+)"
COMMENT_PK_PARAM = "(?P<comment_pk>[0-9]+)"

urlpatterns = [
    re_path(r"^$", PanelsIndexView.as_view(), name="index"),
    re_path(r"^compare/$", ComparePanelsView.as_view(), name="compare_panels_form"),
    re_path(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        ComparePanelsView.as_view(),
        name="compare",
    ),
    re_path(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)/(?P<gene_symbol>[\w\-]+)$",
        CompareGeneView.as_view(),
        name="compare_genes",
    ),
    re_path(
        r"^copy/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        CopyReviewsView.as_view(),
        name="copy_reviews",
    ),
    re_path(rf"^{PK_PARAM}/$", GenePanelView.as_view(), name="detail"),
    re_path(rf"^{PK_PARAM}/update$", UpdatePanelView.as_view(), name="update"),
    re_path(rf"^{PK_PARAM}/promote$", PromotePanelView.as_view(), name="promote"),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/add$",
        PanelAddEntityView.as_view(),
        name="add_entity",
    ),
    re_path(
        rf"^{PK_PARAM}/delete$", DeletePanelAjaxView.as_view(), name="delete_panel"
    ),
    re_path(
        rf"^{PK_PARAM}/reject$", RejectPanelAjaxView.as_view(), name="reject_panel"
    ),
    re_path(
        rf"^{PK_PARAM}/approve$",
        ApprovePanelAjaxView.as_view(),
        name="approve_panel",
    ),
    re_path(
        rf"^{PK_PARAM}/download/(?P<categories>[0-4]+)/$",
        DownloadPanelTSVView.as_view(),
        name="download_panel_tsv",
    ),
    re_path(
        rf"^{PK_PARAM}/download_version/$",
        DownloadPanelVersionTSVView.as_view(),
        name="download_old_panel_tsv",
    ),
    re_path(
        rf"^{PK_PARAM}/{NAME_PARAM}/$",
        RedirectGenesToEntities.as_view(),
        name="redirect_previous_structure",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/$",
        panel_entity_detail_view,
        name="evaluation",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/edit$",
        PanelEditEntityView.as_view(),
        name="edit_entity",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/review$",
        EntityReviewView.as_view(),
        name="review_entity",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/mark_entity_as_ready$",
        toggle_entity_ready_view,
        name="mark_entity_as_ready",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/mark_entity_as_not_ready$",
        toggle_entity_ready_view,
        name="mark_entity_as_not_ready",
    ),
    # AJAX endpoints
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/delete$",
        DeleteEntityAjaxView.as_view(),
        name="delete_entity",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/approve$",
        ApproveEntityAjaxView.as_view(),
        name="approve_entity",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_sources$",
        clear_entity_sources_view,
        name="clear_entity_sources",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_source/(?P<source>(.*))/$",
        clear_entity_source_view,
        name="clear_entity_source",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_source_for_entity_list/(?P<source>(.*))/$",
        clear_entity_source_for_entity_list_view,
        name="clear_entity_source_for_entity_list",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_phenotypes$",
        clear_entity_phenotypes_view,
        name="clear_entity_phenotypes",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_transcript$",
        clear_entity_transcript_view,
        name="clear_entity_transcript",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_publications$",
        clear_entity_publications_view,
        name="clear_entity_publications",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/clear_entity_mode_of_pathogenicity$",
        clear_entity_mode_of_pathogenicity_view,
        name="clear_entity_mode_of_pathogenicity",
    ),
    # AJAX Review endpoints
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_tags/$",
        update_entity_tags_view,
        name="update_entity_tags",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_rating/$",
        update_entity_rating_view,
        name="update_entity_rating",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_moi/$",
        update_entity_moi_view,
        name="update_entity_moi",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_mop/$",
        update_entity_mop_view,
        name="update_entity_mop",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_phenotypes/$",
        update_entity_phenotypes_view,
        name="update_entity_phenotypes",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/update_publications/$",
        update_entity_publications_view,
        name="update_entity_publications",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/delete_evaluation/(?P<evaluation_pk>[0-9]+)/$",
        delete_evaluation_by_user_view,
        name="delete_evaluation_by_user",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/edit_comment/{COMMENT_PK_PARAM}/$",
        edit_entity_comment_form_view,
        name="edit_comment_by_user",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/submit_edit_comment/{COMMENT_PK_PARAM}/$",
        SubmitEntityCommentFormAjaxView.as_view(),
        name="submit_edit_comment_by_user",
    ),
    re_path(
        rf"^{PK_PARAM}/{TYPE_PARAM}/{NAME_PARAM}/delete_comment/{COMMENT_PK_PARAM}/$",
        delete_entity_comment_view,
        name="delete_comment_by_user",
    ),
    re_path(
        rf"^{PK_PARAM}/mark_not_ready$",
        PanelMarkNotReadyView.as_view(),
        name="mark_not_ready",
    ),
    re_path(
        r"^(?P<pk>[a-z0-9]{24})/(?P<uri>.*|$)",
        OldCodeURLRedirect.as_view(),
        name="old_code_url_redirect",
    ),
    re_path(r"^create/", CreatePanelView.as_view(), name="create"),
    re_path(r"^entities/$", EntitiesListView.as_view(), name="entities_list"),
    re_path(
        r"^genes/$", RedirectView.as_view(url="/panels/entities"), name="genes_list"
    ),
    re_path(
        rf"^entities/{NAME_PARAM}$",
        EntityDetailView.as_view(),
        name="entity_detail",
    ),
    re_path(
        rf"^genes/{NAME_PARAM}$",
        GeneDetailRedirectView.as_view(),
    ),
    re_path(r"^activity/$", ActivityListView.as_view(), name="activity"),
    re_path(r"^admin/", AdminView.as_view(), name="admin"),
    re_path(r"^upload_genes/", AdminUploadGenesView.as_view(), name="upload_genes"),
    re_path(r"^download_genes/", DownloadAllGenes.as_view(), name="download_genes"),
    re_path(r"^download_strs/", DownloadAllSTRs.as_view(), name="download_strs"),
    re_path(
        r"^download_regions/", DownloadAllRegions.as_view(), name="download_regions"
    ),

panelapp/panels/models/Level4Title.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.contrib.postgres.fields import ArrayField
from django.db import models


class Level4Title(models.Model):
    name = models.CharField(max_length=255)
    description = models.TextField()
    level3title = models.CharField(max_length=255)
    level2title = models.CharField(max_length=255)
    omim = ArrayField(models.CharField(max_length=255))
    orphanet = ArrayField(models.CharField(max_length=255))
    hpo = ArrayField(models.CharField(max_length=255))

    def __str__(self):
        return str(self.name)

    __hash__ = models.Model.__hash__

    def __eq__(self, other):
        if other == self.name:
            return True
        else:
            return False

    def dict_tr(self):
        return {
            "name": self.name,
            "description": self.description,
            "level3title": self.level3title,
            "level2title": self.level2title,
            "omim": self.omim,
            "orphanet": self.orphanet,
            "hpo": self.hpo,
        }

panelapp/panels/models/activity.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from copy import deepcopy

from django.core.serializers.json import DjangoJSONEncoder
from django.db import models
from django.db.models import (
    JSONField,
    Q,
)
from model_utils.models import TimeStampedModel

from accounts.models import User

from .genepanel import GenePanel


class ActivityManager(models.Manager):
    def visible_to_public(self):
        """Return activities for all publicly visible panels"""

        qs = self.get_queryset()
        qs = qs.filter(
            Q(panel__status=GenePanel.STATUS.public)
            | Q(panel__status=GenePanel.STATUS.promoted)
        )
        return qs

    def visible_to_gel(self):
        """Return activities visible to GeL curators"""

        return self.get_queryset()


class Activity(TimeStampedModel):
    class Meta:
        ordering = ("-created",)

    objects = ActivityManager()

    panel = models.ForeignKey(GenePanel, on_delete=models.SET_NULL, null=True)
    user = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
    text = models.TextField()
    item_type = models.CharField(max_length=32, null=True)  # TODO (Oleg) change to Enum
    entity_type = models.CharField(max_length=32, null=True)
    entity_name = models.CharField(max_length=128, null=True)
    extra_data = JSONField(default=dict, encoder=DjangoJSONEncoder)

    @property
    def panel_version(self):
        return self.extra_data.get("panel_version")

    @property
    def panel_name(self):
        return self.extra_data.get("panel_name")

    @property
    def user_name(self):
        return self.extra_data.get("user_name")

    @classmethod
    def log(cls, user, panel_snapshot, text, extra_info):
        extra_data = deepcopy(extra_info)

        if user:
            extra_data["user_name"] = user.get_full_name()

        extra_data["panel_name"] = panel_snapshot.panel.name
        extra_data["panel_id"] = panel_snapshot.panel_id
        extra_data["panel_version"] = panel_snapshot.version

        if "entity_type" in extra_info:
            extra_data["item_type"] = "entity"
            extra_data["entity_type"] = extra_info["entity_type"]
            extra_data["entity_name"] = extra_info["entity_name"]
        else:
            extra_data["item_type"] = "panel"

        cls.objects.create(
            user=user,
            panel=panel_snapshot.panel,
            text=text,
            extra_data=extra_data,
            item_type=extra_data["item_type"],
            entity_type=extra_data.get("entity_type"),
            entity_name=extra_data.get("entity_name"),
        )

panelapp/panels/templates/panels/entity/review/part_moi.html
{% load django_bootstrap5 %}

<div class="js-toggle-target">
  {{ entity.moi }}
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form class="form d-none js-toggle-target">
  {% for field in edit_entity_moi_form %}
    <div class="add-label-margin">{% bootstrap_field field %}</div>
    <span class="rm">{{ field.label_tag }}</span>
  {% endfor %}
  <button
    type="button"
    class="btn btn-info"
    hx-post="{% url 'panels:update_entity_moi' entity.panel.panel_id entity_type entity_name %}"
    hx-swap="none"
    hx-disabled-elt="this"
  >
    {% include "panels/entity/button_loading_content.html" with text="Update" %}
  </button>
  <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_mop.html
{% load django_bootstrap5 %}

<div class="js-toggle-target">
  {{ entity.mode_of_pathogenicity }}
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form class="form d-none js-toggle-target">
  {% for field in edit_entity_mop_form %}
    <div class="add-label-margin">{% bootstrap_field field %}</div>
    <span class="rm">{{ field.label_tag }}</span>
  {% endfor %}
  <button
    type="button"
    class="btn btn-info"
    hx-post="{% url 'panels:update_entity_mop' entity.panel.panel_id entity_type entity_name %}"
    hx-swap="none"
    hx-disabled-elt="this"
  >
    {% include "panels/entity/button_loading_content.html" with text="Update" %}
  </button>
  <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_phenotypes.html
{% load django_bootstrap5 %}

<div class="js-toggle-target">
  {{ entity.phenotypes|join:"; " }}
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form class="form js-toggle-target d-none">
  {% for field in edit_entity_phenotypes_form %}
    <div class="add-label-margin">{% bootstrap_field field %}</div>
    <span class="rm">{{ field.label_tag }}</span>
  {% endfor %}
  <button
    type="button"
    class="btn btn-info"
    hx-post="{% url 'panels:update_entity_phenotypes' entity.panel.panel_id entity_type entity_name %}"
    hx-swap="none"
    hx-disabled-elt="this"
  >
    {% include "panels/entity/button_loading_content.html" with text="Save phenotypes" %}
  </button>
  <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_publications.html
{% load django_bootstrap5 %}
{% load panel_helpers %}

<div class="js-toggle-target">
  {% if entity.publications %}
  <ul>
    {% for publication in entity.publications %}
      <li>{{ publication|pubmed_link|join:'' }}</li>
    {% endfor %}
  </ul>
  {% endif %}
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form class="form js-toggle-target d-none">
  {% for field in edit_entity_publications_form %}
    <div class="add-label-margin">{% bootstrap_field field %}</div>
    <span class="rm">{{ field.label_tag }}</span>
  {% endfor %}
  <button
    type="button"
    class="btn btn-info"
    hx-post="{% url 'panels:update_entity_publications' entity.panel.panel_id entity_type entity_name %}"
    hx-swap="none"
    hx-disabled-elt="this"
  >
    {% include "panels/entity/button_loading_content.html" with text="Save publications" %}
  </button>
  <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_rating.html
{% load django_bootstrap5 %}
{% load panel_helpers %}

<div class="js-toggle-target">
  <x-rating-badge rating="{{ entity.entity_color_name }}" text="verbose"></x-rating-badge>
  <a href="#" class="add-left-margin link-inherit js-toggle">Edit</a>
</div>
<form class="form d-none js-toggle-target">
  {% for field in edit_entity_rating_form %}
    <div class="add-label-margin">{% bootstrap_field field %}</div>
    <span class="rm">{{ field.label_tag }}</span>
  {% endfor %}
  <button
    type="button"
    class="btn btn-info"
    hx-post="{% url 'panels:update_entity_rating' entity.panel.panel_id entity_type entity_name %}"
    hx-swap="none"
    hx-disabled-elt="this"
  >
    {% include "panels/entity/button_loading_content.html" with text="Update" %}
  </button>
  <a href="#" class="add-left-margin btn btn-link js-toggle">Cancel</a>
</form>

panelapp/panels/templates/panels/entity/review/part_tags.html
{% load django_bootstrap5 %}
<h4 class="add-bottom-margin">Tags</h4>
<div class="card card-body review-table">
  <form class="form">
    {% for field in edit_entity_tags_form %}
      <span class="rm">{{ field.label_tag }}</span>
      {% bootstrap_field field show_label=False %}
    {% endfor %}
    {% if updated %}
      <p class="text-muted js-tag-saved-status add-top-margin">Saved at {{ updated }}</p>
    {% endif %}
    <button
      type="button"
      class="btn btn-info add-top-margin"
      hx-post="{% url 'panels:update_entity_tags' entity.panel.panel_id entity_type entity_name %}"
      hx-swap="none"
      hx-disabled-elt="this"
    >
      {% include "panels/entity/button_loading_content.html" with text="Save changes" %}
    </button>
  </form>
</div>

panelapp/panels/templates/panels/entity/review/review_evaluations.html
{% for comment in entity.get_review_comments %}
  <blockquote class="add-top-margin add-bottom-margin blockquote border-start border-5 ps-3 py-2">
    {{ comment.comment }}
    <h6 class="add-top-margin">{{ comment.user.get_reviewer_name }}, {{ comment.created|date }}</h6>
    {% if request.user == comment.user and panel and entity %}
      <button
        type="button"
        class="btn btn-outline-light-panelapp btn-xs"
        hx-get="{% url 'panels:delete_comment_by_user' panel.panel_id entity_type entity_name comment.pk %}"
        hx-swap="none"
        hx-disabled-elt="this"
      >
        {% include "panels/entity/button_loading_content.html" with text="Delete comment" %}
      </button>
    {% endif %}
  </blockquote>
{% endfor %}